package com.zhiqiyun.open.mvc.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.OrderItem;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zhiqiyun.open.annotation.Permission;
import com.zhiqiyun.open.core.models.bz.BaseDataInfo;
import com.zhiqiyun.open.core.models.bz.HotelInfo;
import com.zhiqiyun.open.core.models.user.OauthInfo;
import com.zhiqiyun.open.core.service.HotelInfoService;
import com.zhiqiyun.open.core.service.OauthService;
import com.zhiqiyun.open.core.service.SequenceService;
import com.zhiqiyun.open.mvc.Result;
import com.zhiqiyun.open.mvc.params.bz.QueryHotelInfoParams;
import com.zhiqiyun.open.mvc.params.bz.SaveHotelInfoParams;
import com.zhiqiyun.open.utils.DateUtil;
import com.zhiqiyun.open.utils.ServletContext;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

@RestController
@RequestMapping("/bz/base/hotel")
public class HotelInfoController {

    @Autowired
    private HotelInfoService hotelInfoService;

    @Autowired
    private SequenceService sequenceService;

    @Autowired
    private OauthService oauthService;

    @Permission(value = "bz.base.hotel.find", tags = "查询酒店")
    @PostMapping("/findPage")
    public Result findPage(@RequestBody QueryHotelInfoParams params) {

        QueryWrapper<HotelInfo> queryWrapper = new QueryWrapper<>();

        if (params.getGrade() != null) {
            queryWrapper.eq("grade", params.getGrade());
        }

        if (StringUtils.isNotBlank(params.getKeyword())) {
            StringBuilder sb = new StringBuilder("select id from bz_base_info where");
            sb.append(" name like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or brief like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or address like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or contacts like ").append("'%").append(params.getKeyword()).append("%'");
            sb.append(" or contact_number like ").append("'%").append(params.getKeyword()).append("%'");
            queryWrapper.inSql("id", sb.toString());
        }

        Page<HotelInfo> page = params.getPage();
        page.addOrder(OrderItem.desc("id"));

        Page<HotelInfo> resultData = this.hotelInfoService.page(page, queryWrapper);

        return Result.instance(Result.Code.SUCCESS).setData(resultData);
    }

    @Permission(value = "bz.base.hotel.add", tags = "保存酒店")
    @PostMapping("/save")
    public Result save(@Valid @RequestBody SaveHotelInfoParams params) {

        this.hotelInfoService.save(this.buildEntity(this.sequenceService.nextId(), params));

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }

    @Permission(value = "bz.base.hotel.edit", tags = "编辑酒店")
    @PostMapping("/updateById")
    public Result updateById(Long id, @Valid @RequestBody SaveHotelInfoParams params) {

        this.hotelInfoService.updateById(this.buildEntity(id, params));

        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }


    private HotelInfo buildEntity(Long id, @Valid SaveHotelInfoParams params) {

        HotelInfo entity = new HotelInfo();
        BaseDataInfo baseDataInfo = new BaseDataInfo();

        BeanUtils.copyProperties(params, entity);
        BeanUtils.copyProperties(params.getBaseDataInfo(), baseDataInfo);


        OauthInfo oauthInfo = this.oauthService.getAuth(ServletContext.getAccessToken());

        baseDataInfo.setCreatedTime(DateUtil.current());
        baseDataInfo.setUpdatedTime(DateUtil.current());
        baseDataInfo.setCreatedBy(oauthInfo.getId());
        baseDataInfo.setUpdatedBy(oauthInfo.getId());

        entity.setBaseDataInfo(baseDataInfo);
        entity.setId(id);
        return entity;
    }

    @Permission(value = "bz.base.hotel.delete", tags = "删除酒店")
    @PostMapping("/deleteByIds")
    public Result deleteByIds(@RequestBody List<Long> ids) {
        this.hotelInfoService.removeByIds(ids);
        return Result.instance(Result.Code.MESSAGE_SUCCESS);
    }
}
